<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <link rel="stylesheet" href="style.css">

    <title>Practice</title>

</head>
<body>
<header>

    <h1 class="title"><span>Better</span>Programming (h1, .classs, span) </h1>
    <nav class="a">
        <a href="#">ARCHIVE</a>
        <a href="#">WRITE FOR US</a>
        <a href="#">STYLE GUIDE</a>
        <a href="#">ABOUT</a>
        <a href="#">VISIT OUR JOB BORDER (nav, .class, a) </a>

    </nav>
</header>

<h2><i>How an Anti-TypeScript<br>"JavaScript Developer" Like<br>Me Became a TypeScript Fan (h2, class, i, br)</i>
</h2>


<h3><i>My journey from not liking TypeScript to loving it (h3, .class, i,)</i>
</h3>
<h4>Why Was I Anti-TypeScript? (h4, .class, p)</h4>
<img src="https://miro.medium.com/max/276/0*o_VAe9UO3Ys1gBBk" alt=""/>


<p>I always felt that adding types to functions/variables and satisfying the TypeScript compiler was over-engineering
    and didn’t provide anymeaningful benefits.<br> Also, it felt slow to work on, as I would always get compilation
    errors that were hard to understand.<br> I would scratch my head trying to figure out the problem.<br>This caused
    some frustration, and I started hating TypeScript.(p, .class, br)</p>
<p>The other reason was advanced TypeScript concepts like generics. <br>They were very hard to understand and I started
    feeling like I was in the Java world, where every piece of code is strongly typed and overwhelming.<br> Even simple
    code like the snippet below scared me when I started learning TypeScript: </p>
<img src="https://miro.medium.com/max/552/1*ccNIwcBOISh4ZJ7kAuaY4A.png" alt=""/>
<p>Because of these reasons, even though I was learning TypeScript by watching tutorials or reading books, I never
    worked on any enterprise application that was written in TypeScript. <br>In fact, I used to choose JavaScript over
    TypeScript (if there was a choice) for take-home assignments as part of the interview process with companies.</p>
<h5>Top 3 Reasons Why I Became a TypeScript Fan (h5, .class, p)</h5>
<ol>
    <li><b>Making impossible states impossible and exhaustive checks (ol,li, b, .class)</b></li>


</ol>
<p>This is the major reason why I love TypeScript. <br> If you would like to know more about this concept, I recommend
    watching the video below. <br>It talks about the Elm language, but the concept is valid for the TypeScript world as
    well: (p, br, .class)</p>

<iframe width="560" height="315" src="https://www.youtube.com/embed/IcgmSRJHu_8" frameborder="0"
        allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture"
        allowfullscreen></iframe>
<p>If you want to see some examples of how to leverage TypeScript in your React applications to avoid impossible states,
    I would recommend reading the following articles:</p>
<ol class="li">
    <li>A real-life example of how a traffic light system would take care of impossible states</li>
    <li>A React component with loading, loaded, and error states (ol, li, .class)</li>

</ol>
<h6>2. Spotting bugs early (h6, .class,p)</h6>
<p>While working on JavaScript, I encountered multiple instances where bugs were spotted in production due to some
    corner case that happened because there was no type checking on the frontend.<br> These bugs can be avoided and
    caught at compile time by the TypeScript compiler, which will save you hours in the DEV-QA cycle. </p> (p, br, class)
<p class="p b"><b>Conclusion (p, b, .class)</b></p>
<ol class="li u">
    <li><u>TypeScript in 50 Lessons</u></li>
    <li><u>Tackling TypeScript</u></li>


</ol> (ol, .class, li, u)
<hr>
<p class="p b"><b>Sign up for The Best of Better Programming</b></p>
<p>A weekly newsletter sent every Friday with the best articles we published that week.<br> Code tutorials, advice,
    career opportunities, and more! Take a look.</p>
<form>
    <input type="email">
    <input type="text">
</form> (form, .class, input)


</body>
</html>